/// <reference types="node" />
import { URL } from "url";
import { Nullable, StringDictionary, TSDataLike, TSDictionary } from "./types";
import { DefaultsConfigurationOptions } from "./tsdefaults";
import { TSLeafOptionalNode, TSMandatoryLeafNode } from "./tsparser";
export interface $envOptions extends DefaultsConfigurationOptions {
    merge?: Nullable<StringDictionary>;
    reference?: Nullable<StringDictionary>;
}
export declare function $env(source: Nullable<string | TSDataLike>, opts?: Nullable<$envOptions>): StringDictionary | null;
export type TSArgumentDictionary = TSDictionary<TSArgument | TSLeafOptionalNode | TSMandatoryLeafNode>;
export interface TSArgument {
    struct: TSLeafOptionalNode | TSMandatoryLeafNode;
    noDoubleDash?: boolean;
    defaultValue?: any;
    short?: string;
    negative?: string;
    negativeShort?: string;
}
export interface TSArgsOptions {
    errors?: Nullable<string[]>;
    arguments?: Nullable<URL | string[]>;
}
export declare function $args(definition: TSArgumentDictionary, opts?: Nullable<TSArgsOptions>): [TSDictionary | null, string[]];
